/* 
 This file was generated by Dashcode.
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	dashcode.setupParts();
	loadPrefs();
	versionCheck();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
	// Stop any timers to prevent CPU usage
	// Remove any preferences as needed
	// widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
	erasePrefs();
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
	// Stop any timers to prevent CPU usage
	updatePrefs();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
	// Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
	// Retrieve any preference values that you need to be synchronized here
	// Use this for an instance key's value:
	// instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
	//
	// Or this for global key's value:
	// globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}

	front.style.display = "none";
	back.style.display = "block";

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) {
		widget.prepareForTransition("ToFront");
		updatePrefs();
	}

	front.style.display="block";
	back.style.display="none";

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
}

if (window.widget) {
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
	widget.onsync = sync;
}



// ---------------------------- //
// Begin app-specific functions //
// ---------------------------- //



var wid = widget.identifier;
var prefType = loadPref(wid+"type",0);
var prefSize = loadPref(wid+"size","128x128");
var prefTile = loadPref(wid+"tile","4x4");
var prefLocation = loadPref(wid+"loc","/opt/local/bin/");
var prefNameSprite = loadPref(wid+"nameSprite","Sheet-%d");
var prefNameFile = loadPref(wid+"nameFile","Files-");
var prefScale = loadPref(wid+"scale",3);
var prefOutput = loadPref(wid+"output",0);

// Preference Saving

function loadPref(key,value) {
	var string = widget.preferenceForKey(key);
	if (string != null) {
		return string;
	} else {
		widget.setPreferenceForKey(value,key);
		return value;
	}
}

function loadPrefs() {
//	alert("ready!");
	document.getElementById("type").object.setSelectedIndex(prefType);
	document.getElementById("size").value = prefSize;
	document.getElementById("tile").value = prefTile;
	document.getElementById("loc").value = prefLocation;
	document.getElementById("nameSprite").value = prefNameSprite;
	document.getElementById("nameFile").value = prefNameFile;
	document.getElementById("scale").object.setSelectedIndex(prefScale);
	document.getElementById("output").object.setSelectedIndex(prefOutput);
	updateOpacity();
//	updateSize(size);
}

function updatePrefs() {
	if (window.widget) {
		widget.setPreferenceForKey(prefType,wid+"type");
		widget.setPreferenceForKey(prefSize,wid+"size");
		widget.setPreferenceForKey(prefTile,wid+"tile");
		widget.setPreferenceForKey(prefLocation,wid+"loc");
		widget.setPreferenceForKey(prefNameSprite,wid+"nameSprite");
		widget.setPreferenceForKey(prefNameFile,wid+"nameFile");
		widget.setPreferenceForKey(prefScale,wid+"scale");
		widget.setPreferenceForKey(prefOutput,wid+"output");
	}
}

function erasePrefs() {
	if (window.widget) {
		widget.setPreferenceForKey(null,wid+"type");
		widget.setPreferenceForKey(null,wid+"size");
		widget.setPreferenceForKey(null,wid+"tile");
		widget.setPreferenceForKey(null,wid+"loc");
		widget.setPreferenceForKey(null,wid+"nameSprite");
		widget.setPreferenceForKey(null,wid+"nameFile");
	}
}

// Basic Functions

function updateType(event) {
	prefType = document.getElementById("type").object.getSelectedIndex();
	updateOpacity();
	updatePrefs();
}

function updateOpacity(event) {
	if (prefType >= 5) {
		document.getElementById("size").style.opacity = 1;
		document.getElementById("tile").style.opacity = 1;
	} else if (prefType == 4) {
		document.getElementById("size").style.opacity = 0.5;
		document.getElementById("tile").style.opacity = 1;
	} else if (prefType == 3) {
		document.getElementById("size").style.opacity = 1;
		document.getElementById("tile").style.opacity = 0.5;
	} else {
		document.getElementById("size").style.opacity = 0.5;
		document.getElementById("tile").style.opacity = 0.5;
	}
}

function updateSize(event) {
	prefSize = document.getElementById("size").value;
}

function updateTile(event) {
	prefTile = document.getElementById("tile").value;
}

function updateLoc(event) {
	prefLoc = document.getElementById("loc").value;
}

function updateNameSprite(event) {
	prefNameSprite = document.getElementById("nameSprite").value;
}

function updateNameFile(event) {
	prefNameFile = document.getElementById("nameFile").value;
}

function updateScale(event) {
	prefScale = document.getElementById("scale").object.getSelectedIndex();
	updatePrefs();
}

function updateOutput(event) {
	prefOutput = document.getElementById("output").object.getSelectedIndex();
	updatePrefs();
}



// Be sure to assign these handlers for the ondragenter and ondragover events on your drop target. These handlers prevent Web Kit from processing drag events so you can handle the drop when it occurs.

function dragEnter(event) {
	event.stopPropagation();
	event.preventDefault();
}

function dragOver(event) {
	event.stopPropagation();
	event.preventDefault();
}

function dragDrop(event) {
	try {
		uri = event.dataTransfer.getData("text/uri-list");
		uri = uri.replace(/file:\/\/localhost/gi, "");
		uri = uri.replace(/\%20/gi, "\\ ");
		uri = uri.split("\n");
		uri = uri.sort(sortAlphaNum);
		var uriParts = uri[0].match(/(.+?)(\d+)(\.\w{3,4})$/);
		if (uriParts == null) uriParts = uri[0].match(/(.+?)(\.\w{3,4})$/);
		if (typeof(uriParts[3])=="undefined") uriParts[3] = uriParts[2];
		var name = uriParts[1]+prefNameSprite+uriParts[3];
		var nameRGB = uriParts[1]+prefNameSprite+".rgb"+uriParts[3];
		var nameAlpha = uriParts[1]+prefNameSprite+".a"+uriParts[3];
		var tile = "";
		var geometry = "";
		var mode = "+0+0 ";
		var padding = 4;
		var scale = "-filter ";

		if (prefType == 1) {
			tile = "-tile x1";
		} else if (prefType == 2) {
			tile = "-tile 1x";
		} else if (prefType == 3) {
			geometry = prefSize;
		} else if (prefType == 4) {
			tile = "-tile "+prefTile;
		} else if (prefType >= 5) {
			geometry = prefSize;
			tile = "-tile "+prefTile;
			if (prefType == 6) {
//				padding = prefSize.split("x");
//				padding = padding[0]*0.1;
				mode = "+"+padding+"+"+padding+" -label '%f\n%[width]x%[height]' ";
				uriParts = uri[0].match(/(.+?)([^\/]+)(\.\w{3,4})$/);
				name = uriParts[1]+prefNameFile+uriParts[2]+uriParts[3];
				nameRGB = uriParts[1]+prefNameFile+uriParts[2]+".flat"+uriParts[3];
				nameAlpha = uriParts[1]+prefNameFile+uriParts[2]+".alpha"+uriParts[3];
			}
		}

		switch (prefScale) {
		case 0:
			scale += "Point ";
			break;
		case 1:
			scale += "Box ";
			break;
		case 2:
			scale += "Cubic ";
			break;
		case 3:
			scale += "Quadratic ";
			break;
		case 4:
			scale += "Gaussian ";
			break;
		case 5:
			scale += "Mitchell ";
			break;
		case 6:
			scale += "Catrom ";
			break;
		case 7:
			scale += "Lanczos ";
			break;
		default:
			scale = "";
		}

alert("scale: "+scale);
alert("prefOutput: "+prefOutput);

		if (uri.length == 1) {
			if (prefOutput == 0 || prefOutput == 3) widget.system(prefLocation+"montage -background none -alpha set "+scale+tile+" -geometry "+geometry+mode+uriParts[1]+"*"+uriParts[3]+" "+name, endHandler).outputString;
			if (prefOutput == 1 || prefOutput == 3) widget.system(prefLocation+"montage -background none -alpha off "+scale+tile+" -geometry "+geometry+mode+uriParts[1]+"*"+uriParts[3]+" "+nameRGB, endHandler).outputString;
			if (prefOutput == 2 || prefOutput == 3) widget.system(prefLocation+"montage -background none -alpha extract "+scale+tile+" -geometry "+geometry+mode+uriParts[1]+"*"+uriParts[3]+" "+nameAlpha, endHandler).outputString;
			alert(prefLocation+"montage -background none -alpha extract "+scale+tile+" -geometry "+geometry+mode+uriParts[1]+"*"+uriParts[3]+" "+nameAlpha);
			showSuccess(event);
		} else {
			if (prefOutput == 0 || prefOutput == 3) widget.system(prefLocation+"montage -background none -alpha set "+scale+tile+" -geometry "+geometry+mode+uri.join(" ")+" "+name, endHandler).outputString;
			if (prefOutput == 1 || prefOutput == 3) widget.system(prefLocation+"montage -background none -alpha off "+scale+tile+" -geometry "+geometry+mode+uri.join(" ")+" "+nameRGB, endHandler).outputString;
			if (prefOutput == 2 || prefOutput == 3) widget.system(prefLocation+"montage -background none -alpha extract "+scale+tile+" -geometry "+geometry+mode+uri.join(" ")+" "+nameAlpha, endHandler).outputString;
			alert(prefLocation+"montage -background none -alpha extract "+scale+tile+" -geometry "+geometry+mode+uri.join(" ")+" "+nameAlpha);
			showSuccess(event);
		}
	} catch (ex) {
		alert("Problem fetching URI: " + ex);
		showFail(event);
	}

	event.stopPropagation();
	event.preventDefault();
}

function endHandler (output) {
//	alert("output = "+output.outputString);
	showMain();
}

function sortName(a, b) {
	var x = a.toLowerCase();
	var y = b.toLowerCase();
	return (x < y) ? -1 : ((x > y) ? 1 : 0);
}

function sortNumber(a, b) {
	return a - b;
}

function sortAlphaNum(a, b) {
	// the next four lines are designed specifically for OS X file arrays
	// and will need to be modified depending on the situation
	var x = a.split("/");
	var y = b.split("/");
	x = x[x.length-1].replace(/\\\s/g," ").split(/(\d+)/);
	y = y[y.length-1].replace(/\\\s/g," ").split(/(\d+)/);
	for (var i in x) {
		if (x[i] && !y[i] || isFinite(x[i]) && !isFinite(y[i])) {
			return -1;
		} else if (!x[i] && y[i] || !isFinite(y[i]) && isFinite(y[i])) {
			return 1;
		} else if (!isFinite(x[i]) && !isFinite(y[i])) {
			x[i] = x[i].toLowerCase();
			y[i] = y[i].toLowerCase();
			if (x[i] < y[i]) return -1;
			if (x[i] > y[i]) return 1;
		} else {
			x[i] = parseFloat(x[i]);
			y[i] = parseFloat(y[i]);
			if (x[i] < y[i]) return -1;
			if (x[i] > y[i]) return 1;
		}
	}
	return 0;
}



// Key listeners

function selectIt(event) {
	if(event.target){
		event = event.target
	}
//	event.focus();
	event.select();
}

// CurrentView animations

function showMain(event) {
	document.getElementById("stack").object.setCurrentView("main", false, true);
}

function showSuccess(event) {
	document.getElementById("stack").object.setCurrentView("success", true, true);
}

function showFail(event) {
	document.getElementById("stack").object.setCurrentView("fail", true, true);
}

function showWrong(event) {
	document.getElementById("stack").object.setCurrentView("wrong", true, true);
}

function showUpdate(event) {
	document.getElementById("stack").object.setCurrentView("update", true, true);
}

// Get Key Value

function getKeyValue(plist, key) {
	var infoPlist = new XMLHttpRequest();
	infoPlist.open("GET", plist, false);
	infoPlist.send(null);
	infoPlist = infoPlist.responseText.replace(/(<([^>]+)>)/ig,"").replace(/\t/ig,"").split("\n");
	for (var i=0; i<infoPlist.length; i++)
		if (infoPlist[i] == key) return infoPlist[i+1];
	return false;
}

// Auto Update

function versionCheck(event) {
	var request = new XMLHttpRequest();
	var address = "http://iaian7.com/files/dashboard/sheets/version.php?RandomKey=" + Date.parse(new Date());
	request.onload = function() { versionCheckEnd(request); };
	request.open("GET", address);
//	request.setRequestHeader("Cache-Control", "no-cache");
	request.send(null);
}

function versionCheckEnd(request){
	if (request.status == 200) {
		var versions = request.responseText.split("\n");
		var bundleVersion = getKeyValue("Info.plist", "CFBundleVersion");
		var websiteVersion = versions[0];
//		alert("bundleVersion: "+bundleVersion);
//		alert("websiteVersion: "+websiteVersion);

		if (websiteVersion > bundleVersion) {
			document.getElementById("newVersion").innerHTML = "version "+versions[0]+"<br/>"+versions[1];
			return showUpdate();
		} else {
//			alert("you have an up to date version");
		}
	} else {
//		alert("there's been an error fetching HTTP data");
	}
}

// Download File

function versionDownload() {
	widget.openURL("http://iaian7.com/files/dashboard/sheets/Sheets.zip");
	showMain();
}

// Visit the website

function iaian7(event)
{
	widget.openURL("http://iaian7.com/dashboard/sheets");
}